      program randcheck
!
!        program to test built-in Random Number Generator
!           (SunStudio 12 intrinsic functions)
!
      implicit none

      integer :: np
      parameter (np=100000)
!
      integer :: iflag
      integer :: ku,kc,nwork

      double precision :: drand
      double precision :: ax(np),awork(np)
      double precision :: sum, ucheck

      integer :: i

      integer :: kread, kwrite

      data kread/5/, kwrite/6/

!       initialize

      ku    = 5
      kc    = 4

!-----------------------------------------------
!       Second built-in Random Number Generator 'drandm'
!          for iflag.ne.0  a seed it planted and
!          a new sequence of random number is generated
!          to get the next random number, iflag has to be zero


!        plant seed

      iflag = 1

      ax(1) = drand(iflag)

!        set flag to zero to fill ax(np)

      iflag=0

      do i=2,np
        ax(i)=drand(iflag)
      end do

!        check for uniformity

      do i=1,np
        awork(i)=ax(i)**ku
      end do

      sum = 0.d0

      do i=1,np
      sum = sum + awork(i)
      end do

      sum = sum/dfloat(np) 

      ucheck = sqrt(dfloat(np))*abs(sum - 1/(dfloat(ku)+1))

      write (kwrite,*) 'sum =',sum,' ucheck = ', ucheck

!       check for correclations

      sum = 0.d0
      nwork = np-kc

      do i=1,nwork
      sum = sum + ax(i)*ax(i+kc)
      end do

      sum = sum/dfloat(nwork)

      write (kwrite,*) 'correlation test for k=',kc,': ',sum

      stop 
      end

