      program stest
!
!        program to test Sobel sequence
!           (SunStudio 12 intrinsic functions)
!
      implicit none

      integer :: np, nplot
      parameter (np=20, nplot=800)
!
      integer :: iseed(10), iflag, iter

      double precision :: xx,xi(2)
      double precision :: a(np), p1(nplot)

      integer :: i, j

      integer :: kread, kwrite, kplot1

      data (iseed(j),j=1,9)/234579,90911,1237,343,39,59,10349,511,101/

      data kread/5/, kwrite/6/
      data kplot1/11/

!        initialize sobel sequence   
      iter = 5
      call sobseq (-1,xx,iseed(iter+1))
 
      write (kwrite,*) ' seed = ',iseed(1)
      write (kwrite,*)


!        generate and print 20 random numbers
!        one-directional

      do i=1,np
        call sobseq (1,xx,iseed(iter+1))
      a(i)=xx
      end do

      do i=1,np
        write (kwrite,*) a(i)
      end do 

      write (kwrite,*)
      write (kwrite,*)


!        generate and print nplot random numbers for plot


      open (kplot1, File = 'plots.dat', Status = 'Unknown')
    
!        initialize sequence again 
      iter=5
      call sobseq (-1,xi,iseed(iter+1))
      
!        generate nplot points 
!        two-directional
  
      do i=1,nplot,2 
      call sobseq (2,xi,iseed(iter+1))
      p1(i)=xi(1)
      p1(i+1)=xi(2)
      end do

      do i=1,nplot-1
        write (kplot1,10000) p1(i),p1(i+1)
      end do

10000 format(2d18.7)


      close (kplot1)

      stop 
      end

